/*
	stltool.h
*/
#ifndef	STLTOOL_H
#define	STLTOOL_H

#ifdef _MSC_VER 
// ev[ǧx}
#pragma warning( disable : 4786 ) //ufobOł̎ʎq؎̂āv
#pragma warning( disable : 4503 ) //uꂽO̒Ez܂BO͐؂̂Ă܂Bv
// forXR[vANSI
#ifndef for
#define for if(0);else for
#endif	// for
#endif	// _MSC_VER

#include	<iostream>
#include	<string>
#include	<map>
#include	<set>
#include	<vector>
#include	<list>
#include	<fstream>
#include	<deque>
#include	<cassert>
using namespace std;

class strvec : public vector<string>
{
public:
	strvec() : vector<string>() {}
	strvec(const_iterator first, const_iterator last) : vector<string>(first, last) {}

	string join(const string& i_delimiter="")
	{
		string r;
		for (iterator i=begin() ; i!=end() ;)
		{
			if ( i!=begin() )
				r += i_delimiter;
			r += *i;
		}
		return r;
	}
};

typedef	map<string, string>	strmap;
typedef	set<string>	stringset;
typedef	list<string>	strlist;
typedef	map<string, int>	strintmap;
typedef	unsigned char	byte;
typedef	pair<string, string>	strpair;
typedef vector<strpair> strpairvec;
/*
{
public:
	strpairvec() : vector<strpair>() {}
	void push_back(const strpair& element)
	{
		this->vector<strpair>::push_back( element );
	}

	void push_back(const string& first, const string& second)
	{
		this->vector<strpair>::push_back( strpair(first, second) );
	}
};
*/

class inimap : public map<string, strmap>	{
public:
	bool	load(const string& iFileName);
	bool	save(const string& iFileName) const;
};
class inivec : public vector< pair<string, strpairvec> > {
public:
	bool	load(const string& iFileName);
};

// f~^܂œǂݍ
bool	getline(istream& i, string& o, int delimtier='\n');
bool	getline(istream& i, int& o, int delimtier='\n');

// intƂ̑ݕϊ
inline int	stoi(const string& s) { return atoi(s.c_str()); }
inline string	itos(int i, const char* iFormat="%d") { char buf[32]; sprintf(buf,iFormat,i); return buf; }

// ĂȂɁB
bool	aredigits(const string& s);
bool	arealphabets(const string& s);

// target̍ŏfind񂪏oʒuԂBpSpΉ
const char*	strstr_hz(const char* target, const char* find);

// u
bool	replace_first(string& str, const string& before, const string& after);
int	replace(string& str, const string& before, const string& after);
template<class T>
int	multi_replace(string& str, T* array1, T* array2, int array_size) {
	int	count=0;
	for (int i=0 ; i<array_size ; ++i)
		count += replace(str, array1[i], array2[i]);
	return	count;
}

// 
bool	erase_first(string& str, const string& before);
int	erase(string& str, const string& before);
// Ώی̐𐔂
int	count(const string& str, const string& target);
// Ώی̑݊mF
inline bool find(const string& str, const string& target) { return	strstr_hz(str.c_str(), target.c_str())!=NULL; }


// dequě납 n ڂQƂ
template<class T>
T&	from_back(deque<T>& iDeque, int n) {
	assert(n>=0 && n<iDeque.size());
	return	iDeque[iDeque.size()-1-n];
}

// t@Cstring
bool	string_from_file(string& o, const string& iFileName);
bool	string_to_file(const string& i, const string& iFileName);
// t@Cstrvec
bool	strvec_from_file(strvec& o, const string& iFileName);
bool	strvec_to_file(const strvec& i, const string& iFileName);
// t@Cstrmap
bool	strmap_from_file(strmap& o, const string& iFileName, const string& dlmt);
bool	strmap_to_file(const strmap& i, const string& iFileName, const string& dlmt);
// Spp킸ꕶ擾
string	get_a_chr(const char*& p);

// Pʂɕ
template<class T>
int	split(const string& i, T& o) {
	const char* p=i.c_str();
	while ( *p != '\0' )
		o.push_back(get_a_chr(p));
	return	o.size();
}

// PPʂɕ max_words͍ő؂oPꐔB0Ȃ琧ȂB
template<class T>
int	split(const string& i, const string& dlmt, T& o, int max_words=0) {
	set<string>	dlmt_set;
	const char* p=dlmt.c_str();
	while ( *p != '\0' )
		dlmt_set.insert(get_a_chr(p));

	if ( dlmt_set.empty() )
		return	split(i, o);

	if ( max_words==1 ) {
		o.push_back(i);
		return	1;
	}

	string	word;
	p=i.c_str();
	while ( *p != '\0' ) {
		string	c = get_a_chr(p);
		if ( dlmt_set.find(c) != dlmt_set.end() ) {
			if ( word.size() > 0 ) {
				o.push_back(word);

				if ( max_words>0 && o.size()+1 >= max_words ) {	// Pꐔ
					word = p;
					break;
				} else
					word="";
			}
		} else
			word += c;
	}
	if ( word.size() > 0 )
		o.push_back(word);

	return	o.size();
}

inline int	splitToSet(const string& iString, set<string>& oSet, int iDelimiter) {
	oSet.clear();
	const char* start=iString.c_str();
	const char* p=start;

	for ( ; *p!='\0' ; ++p ) {
		if ( *p==iDelimiter ) {
			if ( start<p )
				oSet.insert( string(start, p-start) );
			start = p+1;
		}
	}
	if ( start<p )
		oSet.insert(start);
	return	oSet.size();
}



// mapkeÿꗗ擾
template<typename C, typename K, typename V>
int	keys(const map<K,V>& iMap, C& oContainer) {
	oContainer.clear();
	for ( typename map<K,V>::const_iterator i=iMap.begin() ; i!=iMap.end() ; ++i)
		oContainer.push_back(i->first);
	return	oContainer.size();
}
// mapkeÿꗗ擾
template<typename C, typename K, typename V>
C	keys(const map<K,V>& iMap) {
	C	theContainer;
	keys<C,K,V>(iMap, theContainer);
	return	theContainer;
}

// mapvaluëꗗ擾
template<typename C, typename K, typename V>
int	values(const map<K,V>& iMap, C& oContainer) {
	oContainer.clear();
	for ( typename map<K,V>::const_iterator i=iMap.begin() ; i!=iMap.end() ; ++i)
		oContainer.push_back(i->second);
	return	oContainer.size();
}
// mapvaluëꗗ擾
template<typename C, typename K, typename V>
C	values(const map<K,V>& iMap) {
	C	theContainer;
	keys<C,K,V>(iMap, theContainer);
	return	theContainer;
}

// ReivfPstringɌBdlmtԂɋށBԒlstring̑傫
template<class T>
int	combine(string& out, const T& in, const string& dlmt="", bool add_dlmt_on_final=false) {
	typename T::const_iterator i=in.begin();
	if ( add_dlmt_on_final ) {
		for (; i!=in.end() ;++i) {
			out += *i;
			out += dlmt;
		}
	}
	else {
		int	size=in.size();
		for (int n=0 ; n<size ; ++n,++i) {
			out += *i;
			if (n<size-1)
				out += dlmt;
		}
	}
	return	out.size();
}
template<class T>
string	combine(const T& in, const string& dlmt="", bool add_dlmt_on_final=false) {
	string	s;
	combine(s, in, dlmt, add_dlmt_on_final);
	return	s;
}



// t@C݂̑mF
bool	is_exist_file(const string& iFileName);

// str̐擪headłtrue
inline bool	compare_head(const string& str, const string& head) { return str.compare(0, head.size(), head)==0; }
inline bool	compare_head(const char* str, const char* head) { return strncmp(str, head, strlen(head))==0; }
// str̖tailłtrue
bool	compare_tail(const string& str, const string& tail);	

// target̍ŏfind񂪏oʒuԂBpSpΉ
const char*	strstr_hz(const char* target, const char* find);

// ̈ꕶŌɏoʒuԂ
const char*	find_final_char(const char* str, char c);
inline char* find_final_char(char* str, char c) { return const_cast<char*>(find_final_char(static_cast<const char*>(str), c)); }
/*#include	<mbctype.h>	// for _ismbblead,_ismbbtrail
template<class T>
T*	find_final_char(T* str, const T& c) {
	T* last=NULL;
	for (T* p=str ; *p!='\0' ; p+=_ismbblead(*p)?2:1)
		if ( *p==c )
			last=p;
	return	last;
}*/

// ȈՈÍ
string	encode(const string& s);
string	decode(const string& s);

// oCif[^16i\𑊌ݕϊ
string	binary_to_string(const byte* iArray, int iLength);
void	string_to_binary(const string& iString, byte* oArray);
								// oArray ɂ iString.size()/2 oCg̃mۂĂ邱ƁB


// ReiAݗLboolŕԂ
template<typename C, typename E>
bool exists(const C& iC, const E& iE) {
	for ( typename C::const_iterator i=iC.begin() ; i!=iC.end() ; ++i )
		if ( *i == iE )
			return	true;
	return	false;
}
/*
template<typename K, typename V, typename E>
inline bool exists< map<K, V> >(const map<K,V>& iC, const E& iE) {
	return	(iC.find(iE) != iC.end());
}

template<typename T, typename E>
inline bool exists< set<T> >(const set<T>& iC, const E& iE) {
	return	(iC.find(iE) != iC.end());
}
*/

// xor tB^
void	xor_filter(byte* iArray, int iLength, byte _xor);

// tpX̕
string	get_file_name(const string& str);
string	get_folder_name(const string& str);
string	get_extention(const string& str);
// gqύX̂Ԃ
string	set_extention(const string& str, const char* new_ext);
inline string	set_extention(const string& str, const string& new_ext) { return set_extention(str, new_ext.c_str()); }
// gqԂ
inline string	get_extension(const string& str) {
	const char* p = find_final_char(str.c_str(), '.');
	return p ? p+1 : "";
}
// t@CύX̂Ԃ
string	set_filename(const string& str, const char* new_filename);
inline string	set_filename(const string& str, const string& new_filename) { return set_filename(str, new_filename.c_str()); }

// o
ostream& operator<<(ostream& o, const strvec& i);
ostream& operator<<(ostream& o, const strmap& i);
ostream& operator<<(ostream& o, const strintmap& i);
inline ostream& operator<<(ostream& o, const strpairvec& i) {
	for ( strpairvec::const_iterator p=i.begin() ; p!=i.end() ; ++p )
		o << p->first << ": " << p->second << endl;
	return	o;
}


// 
istream& operator>>(istream& i, strvec& o);
istream& operator>>(istream& i, strmap& o);
istream& operator>>(istream& i, strintmap& o);

/*
// Ȃ񂩁A܂gĂȂ́BB

// t@CANZT
template<class T>
bool	put(const char* iFileName, T& i) {
	ofstream	o(iFileName);
	if ( !o.is_open() )
		return	false;
	o<<i;
	return	true;
}
template<class T>
bool	get(const char* iFileName, T& o) {
	ifstream	i(iFileName);
	if ( !i.is_open() )
		return	false;
	i>>o;
	return	true;
}


template<class T>
bool	read_text_file(
	T& oT,	// require "push_back" method. vector, list, deque, ...
	const string& iFileName) 
{
	ifstream	in(iFileName.c_str());
	if ( !in.is_open() )
		return	false;
	while ( in.peek() != EOF ) {
		// Psǂݍ
		strstream	line;
		int	c;
		while ( (c=in.get()) != '\n' && c!=EOF)
			line.put(c);
		line.put('\0');

		// sXg[ŒAesɑ΂
		char* p=line.str();
		oT.push_back(p);
		// sXg[̌Œ
		line.rdbuf()->freeze(0);
	}
	in.close();
	return	true;
}

template<class T>
bool	write_text_file(
	const T& iT,	// Reibegin()end()ForwardAccessIteratorvBוɂ operator<< vBstringȁB
	const string& iFileName)
{
	ofstream	out(iFileName.c_str());
	if ( !out.is_open() )
		return	false;
	T::const_iterator	it;
	for (it=iT.begin() ; it!=iT.end() ; ++it)
		out << *it << endl;
	out.close();
	return	true;
}
*/


// 32bit
extern void	randomize(int);
#ifndef POSIX
extern int	random();
#endif

// printf݊ŕ𐶐Astring^ŕԂB
extern string stringf(const char* iFormat, ...);

// Cӂ̌ľܓBfigureȗ͏ʂľܓB
template<typename T>
T	round(T num, const int figure=0) {
	if ( figure>=0 ) {
		for (int i=0 ; i<figure ; ++i) { num *= 10; }
		num = int(num + static_cast<T>(0.5));
		for (int i=0 ; i<figure ; ++i) { num /= 10; }
	}
	else {
		for (int i=0 ; i>figure ; --i) { num /= 10; }
		num = int(num + static_cast<T>(0.5));
		for (int i=0 ; i>figure ; --i) { num *= 10; }
	}
	return	num;
}






// fBNg؂
#ifdef POSIX
  #define DIR_CHAR '/'
  inline string unify_dir_char(const string& i_str) { string r=i_str; replace(r, "\\", "/"); return r; }
#else
  #define DIR_CHAR '\\'
  inline string unify_dir_char(const string& i_str) { string r=i_str; replace(r, "/", "\\"); return r; }
#endif


// DOS/WindowsHTTPȂǂɂsf~^
static const string CRLF = "\x0d\x0a";


#endif	//	STLTOOL_H
