#include "SakuraClient.h"

#ifndef POSIX
#  include <windows.h> // HMODULE,BOOL,HGLOBALƂ
#endif


// dllz_[Bdll[hăNGXg𑗂
class SakuraDLLClient : public SakuraClient
{
public:
	SakuraDLLClient();
	virtual ~SakuraDLLClient();

	// ͂߂
	virtual bool load(
		const string& i_sender,
		const string& i_charset,
		const string& i_protocol,
		const string& i_protocol_version,
		const string& i_work_folder,	// ƃfBNgBDLL::load̈BŌ \ ܂ / Kv
		const string& i_dll_fullpath);	// DLL̃tpX

	// 
	virtual void unload();

	// o[W擾BGET Version"SAORI/1.0" ݂̂ԂB
	virtual string get_version(const string& i_security_level);

	// f̃NGXg𑗂Af̃X|X󂯎B
	virtual string request(const string& i_request_string);

	// NGXg𑗂AX|X󂯎B߂l̓^[R[hB
	virtual int request(
		const string& i_command,
		const strpairvec& i_data,
		strpairvec& o_data);

private:
	string m_sender;
	string m_charset;
	string m_protocol;
	string m_protocol_version;

#ifdef POSIX
	void*   mModule;
	bool    (*mLoad)(char* h, long len);
	char*   (*mRequest)(char* h, long* len);
	bool    (*mUnload)();
#else
	HMODULE	mModule;
	BOOL	(*mLoad)(HGLOBAL h, long len);
	HGLOBAL	(*mRequest)(HGLOBAL h, long* len);
	BOOL	(*mUnload)();
#endif
};

